<template>
  <div
    class="ui modal"
    id="new-diet-modal"
  >
    <i class="close icon"></i>
    <div class="header">
      Ajouter un nouveau régime
    </div>
    <div class="content">
      <div
        class="ui form"
        :class="loading ? 'loading' : ''"
        @submit.prevent="submit"
      >
        <div class="fields">
          <div class="six wide required field">
            <label>Nom du régime</label>
            <input
              placeholder="Nom"
              type="text"
              v-model="name"
            >
          </div>
          <div class="six wide field">
            <label>Description</label>
            <input
              placeholder="Ajouter une description"
              type="text"
              required
              v-model="description"
            >
          </div>
        </div>
      </div>
    </div>

    <div class="actions">
      <div
        class="ui toggle checkbox"
        :class="addAnother ? 'checked' : ''"
        @click="toggleAddAnother"
      >
        <input
          name="addAnother"
          type="checkbox"
          class="hidden"
          tabindex="0"
          :checked="addAnother"
        >
        <label>Ajouter un autre ensuite</label>
      </div>

      <div
        class="ui red basic button"
        @click="cancel"
      >Anuler</div>

      <div
        class="ui primary button"
        :class="loading ? 'loading disabled' : ''"
        @click="submit"
      >OK</div>
    </div>
  </div>
</template>

<script>
import { mapActions, mapGetters } from 'vuex'

import store from '@/store/Store'

export default {
  name: 'ModalNewDiet',
  store,
  data () {
    return {
      addAnother: false,
      name: '',
      description: ''
    }
  },
  mounted () {
    // eslint-disable-next-line
    $('#new-diet-modal')
      .modal('setting', 'transition', 'scale')
  },
  methods: {
    ...mapActions({
      addDiet: 'DietsStore/addDiet'
    }),
    toggleAddAnother () {
      this.addAnother = !this.addAnother
    },
    cancel () {
      // eslint-disable-next-line
      $('#new-diet-modal')
        .modal('hide')
    },
    submit () {
      var self = this

      let diet = {
        name: this.name,
        description: this.description
      }

      this.addDiet(diet)
        .then((response) => {
          this.$toastr.s(diet.name + ' bien ajouté')
          if (!self.addAnother) {
            // eslint-disable-next-line
            $('#new-diet-modal')
              .modal('hide')
          }
          this.emptyModal()
        },
        (error) => {
          this.$toastr.e(error.response.data.message)
        })
    },
    emptyModal () {
      // vider les champs
      this.name = ''
      this.description = ''
    }
  },
  computed: {
    ...mapGetters({
      loading: 'loading'
    })
  }
}
</script>
